Index: squid/src/fs/ufs/store_dir_ufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/ufs/store_dir_ufs.c,v
retrieving revision 1.1.6.6.2.2
retrieving revision 1.1.6.6.2.3
diff -u -r1.1.6.6.2.2 -r1.1.6.6.2.3
--- squid/src/fs/ufs/store_dir_ufs.c	2 May 2000 22:50:30 -0000	1.1.6.6.2.2
+++ squid/src/fs/ufs/store_dir_ufs.c	14 May 2000 23:22:20 -0000	1.1.6.6.2.3
@@ -1716,22 +1512,22 @@
 static void
 storeUfsDirFree(SwapDir * s)
 {
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)s->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) s->fsdata;
     if (ufsinfo->swaplog_fd > -1) {
 	file_close(ufsinfo->swaplog_fd);
 	ufsinfo->swaplog_fd = -1;
     }
     filemapFreeMemory(ufsinfo->map);
     xfree(ufsinfo);
-    s->fsdata = NULL; /* Will aid debugging... */
+    s->fsdata = NULL;		/* Will aid debugging... */
 
 }
 
 char *
-storeUfsDirFullPath(SwapDir *SD, sfileno filn, char *fullpath)
+storeUfsDirFullPath(SwapDir * SD, sfileno filn, char *fullpath)
 {
     LOCAL_ARRAY(char, fullfilename, SQUID_MAXPATHLEN);
-    ufsinfo_t *ufsinfo = (ufsinfo_t *)SD->fsdata;
+    ufsinfo_t *ufsinfo = (ufsinfo_t *) SD->fsdata;
     int L1 = ufsinfo->l1;
     int L2 = ufsinfo->l2;
     if (!fullpath)
@@ -1751,28 +1547,28 @@
  * This is called by storeCleanup() if -S was given on the command line.
  */
 static int
-storeUfsCleanupDoubleCheck(SwapDir *sd, StoreEntry *e)
+storeUfsCleanupDoubleCheck(SwapDir * sd, StoreEntry * e)
 {
     struct stat sb;
 
     if (stat(storeUfsDirFullPath(sd, e->swap_filen, NULL), &sb) < 0) {
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: MISSING SWAP FILE\n");
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: PATH %s\n",
-            storeUfsDirFullPath(sd, e->swap_filen, NULL));
-        storeEntryDump(e, 0);
-        return -1;
-    }       
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: MISSING SWAP FILE\n");
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: PATH %s\n",
+	    storeUfsDirFullPath(sd, e->swap_filen, NULL));
+	storeEntryDump(e, 0);
+	return -1;
+    }
     if (e->swap_file_sz != sb.st_size) {
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: SIZE MISMATCH\n");
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: PATH %s\n",
-            storeUfsDirFullPath(sd, e->swap_filen, NULL));
-        debug(20, 0) ("storeUfsCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
-            e->swap_file_sz, (int) sb.st_size); 
-        storeEntryDump(e, 0); 
-        return -1;
-    }       
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: SIZE MISMATCH\n");
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: PATH %s\n",
+	    storeUfsDirFullPath(sd, e->swap_filen, NULL));
+	debug(20, 0) ("storeUfsCleanupDoubleCheck: ENTRY SIZE: %d, FILE SIZE: %d\n",
+	    e->swap_file_sz, (int) sb.st_size);
+	storeEntryDump(e, 0);
+	return -1;
+    }
     return 0;
 }
 
@@ -1782,7 +1578,7 @@
  * Called when a *new* fs is being setup.
  */
 void
-storeUfsDirParse(SwapDir *sd, int index, char *path)
+storeUfsDirParse(SwapDir * sd, int index, char *path)
 {
     char *token;
     int i;
@@ -1810,7 +1606,7 @@
 
     ufsinfo = xmalloc(sizeof(ufsinfo_t));
     if (ufsinfo == NULL)
-        fatal("storeUfsDirParse: couldn't xmalloc() ufsinfo_t!\n");
+	fatal("storeUfsDirParse: couldn't xmalloc() ufsinfo_t!\n");
 
     sd->index = index;
     sd->path = xstrdup(path);
@@ -1819,7 +1615,7 @@
     ufsinfo->l1 = l1;
     ufsinfo->l2 = l2;
     ufsinfo->swaplog_fd = -1;
-    ufsinfo->map = NULL; /* Debugging purposes */
+    ufsinfo->map = NULL;	/* Debugging purposes */
     ufsinfo->suggest = 0;
     sd->flags.read_only = read_only;
     sd->init = storeUfsDirInit;
@@ -1843,41 +1639,12 @@
     sd->log.open = storeUfsDirOpenSwapLog;
     sd->log.close = storeUfsDirCloseSwapLog;
     sd->log.write = storeUfsDirSwapLog;
-    sd->log.clean.open = storeUfsDirWriteCleanOpen;
+    sd->log.clean.start = storeUfsDirWriteCleanStart;
+    sd->log.clean.nextentry = storeUfsDirCleanLogNextEntry;
+    sd->log.clean.done = storeUfsDirWriteCleanDone;
 
     /* Initialise replacement policy stuff */
-#if HEAP_REPLACEMENT
-    /*
-     * Create new heaps with cache replacement policies attached to them.
-     * The cache replacement policy is specified as either GDSF or LFUDA in
-     * the squid.conf configuration file.  Note that the replacement policy
-     * applies only to the disk replacement algorithm.  Memory replacement
-     * always uses GDSF since we want to maximize object hit rate.
-     */
-    if (Config.replPolicy) {
-        if (tolower(Config.replPolicy[0]) == 'g') {
-            debug(20, 1) ("Using GDSF disk replacement policy\n");
-            sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-        } else if (tolower(Config.replPolicy[0]) == 'l') {
-            if (tolower(Config.replPolicy[1]) == 'f') {
-                debug(20, 1) ("Using LFUDA disk replacement policy\n");
-                sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_LFUDA);
-            } else if (tolower(Config.replPolicy[1]) == 'r') {
-                debug(20, 1) ("Using LRU heap disk replacement policy\n");
-                sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_LRU);
-            }
-        } else {
-            debug(20, 1) ("Unrecognized replacement_policy; using GDSF\n");
-            sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-        }
-    } else {
-        debug(20, 1) ("Using default disk replacement policy (GDSF)\n");
-        sd->repl.heap.heap = new_heap(10000, HeapKeyGen_StoreEntry_GDSF);
-    }
-#else
-    sd->repl.lru.list.head = NULL;
-    sd->repl.lru.list.tail = NULL;
-#endif
+    sd->repl = createRemovalPolicy(Config.replPolicy);
 }
 
 /*
@@ -1891,7 +1658,7 @@
 }
 
 void
-storeFsSetup_ufs(storefs_entry_t *storefs)
+storeFsSetup_ufs(storefs_entry_t * storefs)
 {
     assert(!ufs_initialised);
     storefs->parsefunc = storeUfsDirParse;
@@ -1900,4 +1667,3 @@
     ufs_state_pool = memPoolCreate("UFS IO State data", sizeof(ufsstate_t));
     ufs_initialised = 1;
 }
-
--- /dev/null	Wed Feb 14 00:44:00 2007
+++ squid/src/repl/heap/store_heap_replacement.c	Wed Feb 14 00:44:13 2007
@@ -0,0 +1,105 @@
+
+/*
+ * $Id$
+ *
+ * DEBUG: section 20    Storage Manager Heap-based replacement
+ * AUTHOR: John Dilley
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
+ *  the Regents of the University of California.  Please see the
+ *  COPYRIGHT file for full details.  Squid incorporates software
+ *  developed and/or copyrighted by other sources.  Please see the
+ *  CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+/*
+ * The code in this file is Copyrighted (C) 1999 by Hewlett Packard.
+ * 
+ *
+ * For a description of these cache replacement policies see --
+ *  http://www.hpl.hp.com/techreports/1999/HPL-1999-69.html
+ */
+
+#include "squid.h"
+#include "heap.h"
+
+/*
+ * Key generation function to implement the LFU-DA policy (Least
+ * Frequently Used with Dynamic Aging).  Similar to classical LFU
+ * but with aging to handle turnover of the popular document set.
+ * Maximizes byte hit rate by keeping more currently popular objects
+ * in cache regardless of size.  Achieves lower hit rate than GDS
+ * because there are more large objects in cache (so less room for
+ * smaller popular objects).
+ * 
+ * This version implements a tie-breaker based upon recency
+ * (e->lastref): for objects that have the same reference count
+ * the most recent object wins (gets a higher key value).
+ */
+heap_key HeapKeyGen_StoreEntry_LFUDA(void *entry, double age)
+{
+    StoreEntry *e = entry;
+    double tie;
+    if (e->lastref <= 0)
+	tie = 0.0;
+    else if (squid_curtime <= e->lastref)
+	tie = 0.0;
+    else
+	tie = 1.0 - exp((double) (e->lastref - squid_curtime) / 86400.0);
+    return age + (double) e->refcount - tie;
+}
+
+
+/*
+ * Key generation function to implement the GDS-Frequency policy.
+ * Similar to Greedy Dual-Size Hits policy, but adds aging of
+ * documents to prevent pollution.  Maximizes object hit rate by
+ * keeping more small, popular objects in cache.  Achieves lower
+ * byte hit rate than LFUDA because there are fewer large objects
+ * in cache.
+ * 
+ * This version implements a tie-breaker based upon recency
+ * (e->lastref): for objects that have the same reference count
+ * the most recent object wins (gets a higher key value).
+ */
+heap_key HeapKeyGen_StoreEntry_GDSF(void *entry, double age)
+{
+    StoreEntry *e = entry;
+    double size = e->swap_file_sz ? (double) e->swap_file_sz : 1.0;
+    double tie = (e->lastref > 1) ? (1.0 / e->lastref) : 1.0;
+    return age + ((double) e->refcount / size) - tie;
+}
+
+/* 
+ * Key generation function to implement the LRU policy.  Normally
+ * one would not do this with a heap -- use the linked list instead.
+ * For testing and performance characterization it was useful.
+ * Don't use it unless you are trying to compare performance among
+ * heap-based replacement policies...
+ */
+heap_key HeapKeyGen_StoreEntry_LRU(void *entry, double age)
+{
+    StoreEntry *e = entry;
+    return (heap_key) e->lastref;
+}
--- /dev/null	Wed Feb 14 00:44:00 2007
+++ squid/src/repl/heap/store_heap_replacement.h	Wed Feb 14 00:44:13 2007
@@ -0,0 +1,3 @@
+extern heap_key HeapKeyGen_StoreEntry_LFUDA(void *entry, double age);
+extern heap_key HeapKeyGen_StoreEntry_GDSF(void *entry, double age);
+extern heap_key HeapKeyGen_StoreEntry_LRU(void *entry, double age);
--- /dev/null	Wed Feb 14 00:44:00 2007
+++ squid/src/repl/heap/store_repl_heap.c	Wed Feb 14 00:44:13 2007
@@ -0,0 +1,301 @@
+
+/*
+ * $Id$
+ *
+ * DEBUG: section ?     HEAP based removal policies
+ * AUTHOR: Henrik Nordstrom
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
+ *  Duane Wessels and the University of California San Diego.  Please
+ *  see the COPYRIGHT file for full details.  Squid incorporates
+ *  software developed and/or copyrighted by other sources.  Please see
+ *  the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+#include "heap.h"
+#include "store_heap_replacement.h"
+
+REMOVALPOLICYCREATE createRemovalPolicy_heap;
+
+static int nr_heap_policies = 0;
+
+typedef struct _HeapPolicyData HeapPolicyData;
+struct _HeapPolicyData {
+    RemovalPolicy *policy;
+    heap *heap;
+    heap_key_func *keyfunc;
+    int count;
+    int nwalkers;
+    enum heap_entry_type
+    { TYPE_UNKNOWN = 0, TYPE_STORE_ENTRY, TYPE_STORE_MEM }
+    type;
+};
+
+/* Hack to avoid having to remember the RemovalPolicyNode location.
+ * Needed by the purge walker.
+ */
+static enum heap_entry_type
+heap_guessType(StoreEntry * entry, RemovalPolicyNode * node)
+{
+    if (node == &entry->repl)
+	return TYPE_STORE_ENTRY;
+    if (entry->mem_obj && node == &entry->mem_obj->repl)
+	return TYPE_STORE_MEM;
+    fatal("Heap Replacement: Unknown StoreEntry node type");
+    return TYPE_UNKNOWN;
+}
+#define SET_POLICY_NODE(entry,value) \
+    switch(heap->type) { \
+    case TYPE_STORE_ENTRY: entry->repl.data = value; break ; \
+    case TYPE_STORE_MEM: entry->mem_obj->repl.data = value ; break ; \
+    default: break; \
+    }
+
+static void
+heap_add(RemovalPolicy * policy, StoreEntry * entry, RemovalPolicyNode * node)
+{
+    HeapPolicyData *heap = policy->_data;
+    assert(!node->data);
+    node->data = heap_insert(heap->heap, entry);
+    heap->count += 1;
+    if (!heap->type)
+	heap->type = heap_guessType(entry, node);
+}
+
+static void
+heap_remove(RemovalPolicy * policy, StoreEntry * entry,
+    RemovalPolicyNode * node)
+{
+    HeapPolicyData *heap = policy->_data;
+    heap_node *hnode = node->data;
+    if (!hnode)
+	return;
+    heap_delete(heap->heap, hnode);
+    node->data = NULL;
+    heap->count -= 1;
+}
+
+static void
+heap_referenced(RemovalPolicy * policy, const StoreEntry * entry,
+    RemovalPolicyNode * node)
+{
+    HeapPolicyData *heap = policy->_data;
+    heap_node *hnode = node->data;
+    if (!hnode)
+	return;
+    heap_update(heap->heap, hnode, (StoreEntry *) entry);
+}
+
+/** RemovalPolicyWalker **/
+
+typedef struct _HeapWalkData HeapWalkData;
+struct _HeapWalkData
+{
+    int current;
+};
+
+const StoreEntry *
+heap_walkNext(RemovalPolicyWalker * walker)
+{
+    HeapWalkData *heap_walk = walker->_data;
+    RemovalPolicy *policy = walker->_policy;
+    HeapPolicyData *heap = policy->_data;
+    StoreEntry *entry;
+    if (heap_walk->current >= heap_nodes(heap->heap))
+	return NULL;		/* done */
+    entry = (StoreEntry *) heap_peep(heap->heap, heap_walk->current++);
+    return entry;
+}
+
+static void
+heap_walkDone(RemovalPolicyWalker * walker)
+{
+    RemovalPolicy *policy = walker->_policy;
+    HeapPolicyData *heap = policy->_data;
+    assert(strcmp(policy->_type, "heap") == 0);
+    assert(heap->nwalkers > 0);
+    heap->nwalkers -= 1;
+    safe_free(walker->_data);
+    cbdataFree(walker);
+}
+
+static RemovalPolicyWalker *
+heap_walkInit(RemovalPolicy * policy)
+{
+    HeapPolicyData *heap = policy->_data;
+    RemovalPolicyWalker *walker;
+    HeapWalkData *heap_walk;
+    heap->nwalkers += 1;
+    walker = xcalloc(1, sizeof(*walker));
+    heap_walk = xcalloc(1, sizeof(*heap_walk));
+    heap_walk->current = 0;
+    walker->_policy = policy;
+    walker->_data = heap_walk;
+    walker->Next = heap_walkNext;
+    walker->Done = heap_walkDone;
+    cbdataAdd(walker, cbdataXfree, 0);
+    return walker;
+}
+
+/** RemovalPurgeWalker **/
+
+typedef struct _HeapPurgeData HeapPurgeData;
+struct _HeapPurgeData
+{
+    link_list *locked_entries;
+    heap_key min_age;
+};
+
+static StoreEntry *
+heap_purgeNext(RemovalPurgeWalker * walker)
+{
+    HeapPurgeData *heap_walker = walker->_data;
+    RemovalPolicy *policy = walker->_policy;
+    HeapPolicyData *heap = policy->_data;
+    StoreEntry *entry;
+    heap_key age;
+  try_again:
+    if (!heap_nodes(heap->heap) > 0)
+	return NULL;		/* done */
+    age = heap_peepminkey(heap->heap);
+    entry = heap_extractmin(heap->heap);
+    if (storeEntryLocked(entry)) {
+	linklistPush(&heap_walker->locked_entries, entry);
+	goto try_again;
+    }
+    SET_POLICY_NODE(entry, NULL);
+    return entry;
+}
+
+static void
+heap_purgeDone(RemovalPurgeWalker * walker)
+{
+    HeapPurgeData *heap_walker = walker->_data;
+    RemovalPolicy *policy = walker->_policy;
+    HeapPolicyData *heap = policy->_data;
+    StoreEntry *entry;
+    assert(strcmp(policy->_type, "heap") == 0);
+    assert(heap->nwalkers > 0);
+    heap->nwalkers -= 1;
+    if (heap_walker->min_age > 0)
+	heap->heap->age = heap_walker->min_age;
+    /*
+     * Reinsert the locked entries
+     */
+    while ((entry = linklistShift(&heap_walker->locked_entries))) {
+	heap_node *node = heap_insert(heap->heap, entry);
+	SET_POLICY_NODE(entry, node);
+    }
+    safe_free(walker->_data);
+    cbdataFree(walker);
+}
+
+static RemovalPurgeWalker *
+heap_purgeInit(RemovalPolicy * policy, int max_scan)
+{
+    HeapPolicyData *heap = policy->_data;
+    RemovalPurgeWalker *walker;
+    HeapPurgeData *heap_walk;
+    heap->nwalkers += 1;
+    walker = xcalloc(1, sizeof(*walker));
+    heap_walk = xcalloc(1, sizeof(*heap_walk));
+    heap_walk->min_age = 0.0;
+    heap_walk->locked_entries = NULL;
+    walker->_policy = policy;
+    walker->_data = heap_walk;
+    walker->max_scan = max_scan;
+    walker->Next = heap_purgeNext;
+    walker->Done = heap_purgeDone;
+    cbdataAdd(walker, cbdataXfree, 0);
+#if HEAP_REPLACEMENT_DEBUG
+    if (!verify_heap_property(heap->heap)) {
+	debug(20, 1) ("Heap property violated!\n");
+    }
+#endif
+    return walker;
+}
+
+static void
+heap_free(RemovalPolicy * policy)
+{
+    HeapPolicyData *heap = policy->_data;
+    /* Make some verification of the policy state */
+    assert(strcmp(policy->_type, "heap") == 0);
+    assert(heap->nwalkers);
+    assert(heap->count);
+    /* Ok, time to destroy this policy */
+    safe_free(policy->_data);
+    memset(policy, 0, sizeof(*policy));
+    cbdataFree(policy);
+}
+
+RemovalPolicy *
+createRemovalPolicy_heap(wordlist * args)
+{
+    RemovalPolicy *policy;
+    HeapPolicyData *heap_data;
+    char *keytype;
+    /* Allocate the needed structures */
+    policy = xcalloc(1, sizeof(*policy));
+    heap_data = xcalloc(1, sizeof(*heap_data));
+    /* cbdata register the policy */
+    cbdataAdd(policy, cbdataXfree, 0);
+    /* Initialize the policy data */
+    heap_data->policy = policy;
+    if (args) {
+	keytype = args->key;
+	args = args->next;
+    } else {
+	debug(20, 1) ("createRemovalPolicy_heap: No key type specified. Using LRU\n");
+	keytype = "LRU";
+    }
+    if (!strcmp(keytype, "GDSF"))
+	heap_data->keyfunc = HeapKeyGen_StoreEntry_GDSF;
+    else if (!strcmp(keytype, "LFUDA"))
+	heap_data->keyfunc = HeapKeyGen_StoreEntry_LFUDA;
+    else if (!strcmp(keytype, "LRU"))
+	heap_data->keyfunc = HeapKeyGen_StoreEntry_LRU;
+    else {
+	debug(20, 0) ("createRemovalPolicy_heap: Unknown key type \"%s\". Using LRU\n",
+	    keytype);
+	heap_data->keyfunc = HeapKeyGen_StoreEntry_LRU;
+    }
+    /* No additional arguments expected */
+    assert(!args);
+    heap_data->heap = new_heap(1000, heap_data->keyfunc);
+    /* Populate the policy structure */
+    policy->_type = "heap";
+    policy->_data = heap_data;
+    policy->Free = heap_free;
+    policy->Add = heap_add;
+    policy->Remove = heap_remove;
+    policy->Referenced = NULL;
+    policy->Dereferenced = heap_referenced;
+    policy->WalkInit = heap_walkInit;
+    policy->PurgeInit = heap_purgeInit;
+    /* Increase policy usage count */
+    nr_heap_policies += 0;
+    return policy;
+}
--- /dev/null	Wed Feb 14 00:44:00 2007
+++ squid/src/repl/lru/store_repl_lru.c	Wed Feb 14 00:44:13 2007
@@ -0,0 +1,358 @@
+
+/*
+ * $Id$
+ *
+ * DEBUG: section ?     LRU Removal policy
+ * AUTHOR: Henrik Nordstrom
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by the
+ *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
+ *  Duane Wessels and the University of California San Diego.  Please
+ *  see the COPYRIGHT file for full details.  Squid incorporates
+ *  software developed and/or copyrighted by other sources.  Please see
+ *  the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+
+REMOVALPOLICYCREATE createRemovalPolicy_lru;
+
+typedef struct _LruPolicyData LruPolicyData;
+struct _LruPolicyData {
+    RemovalPolicy *policy;
+    dlink_list list;
+    int count;
+    int nwalkers;
+    enum heap_entry_type
+    { TYPE_UNKNOWN = 0, TYPE_STORE_ENTRY, TYPE_STORE_MEM }
+    type;
+};
+
+/* Hack to avoid having to remember the RemovalPolicyNode location.
+ * Needed by the purge walker
+ */
+static enum heap_entry_type
+repl_guessType(StoreEntry * entry, RemovalPolicyNode * node)
+{
+    if (node == &entry->repl)
+	return TYPE_STORE_ENTRY;
+    if (entry->mem_obj && node == &entry->mem_obj->repl)
+	return TYPE_STORE_MEM;
+    fatal("Heap Replacement: Unknown StoreEntry node type");
+    return TYPE_UNKNOWN;
+}
+#define SET_POLICY_NODE(entry,value) \
+    switch(lru->type) { \
+    case TYPE_STORE_ENTRY: entry->repl.data = value; break ; \
+    case TYPE_STORE_MEM: entry->mem_obj->repl.data = value ; break ; \
+    default: break; \
+    }
+
+typedef struct _LruNode LruNode;
+struct _LruNode
+{
+    /* Note: the dlink_node MUST be the first member of the LruNode
+     * structure. This member is later pointer typecasted to LruNode *.
+     */
+    dlink_node node;
+};
+
+static MemPool *lru_node_pool = NULL;
+static int nr_lru_policies = 0;
+
+static void
+lru_add(RemovalPolicy * policy, StoreEntry * entry, RemovalPolicyNode * node)
+{
+    LruPolicyData *lru = policy->_data;
+    LruNode *lru_node;
+    assert(!node->data);
+    node->data = lru_node = memPoolAlloc(lru_node_pool);
+    dlinkAddTail(entry, &lru_node->node, &lru->list);
+    lru->count += 1;
+    if (!lru->type)
+	lru->type = repl_guessType(entry, node);
+}
+
+static void
+lru_remove(RemovalPolicy * policy, StoreEntry * entry, RemovalPolicyNode * node)
+{
+    LruPolicyData *lru = policy->_data;
+    LruNode *lru_node = node->data;
+    if (!lru_node)
+	return;
+    assert(lru_node->node.data == entry);
+    node->data = NULL;
+    dlinkDelete(&lru_node->node, &lru->list);
+    memPoolFree(lru_node_pool, lru_node);
+    lru->count -= 1;
+}
+
+static void
+lru_referenced(RemovalPolicy * policy, const StoreEntry * entry,
+    RemovalPolicyNode * node)
+{
+    LruPolicyData *lru = policy->_data;
+    LruNode *lru_node = node->data;
+    if (!lru_node)
+	return;
+    dlinkDelete(&lru_node->node, &lru->list);
+    dlinkAdd((void *) entry, &lru_node->node, &lru->list);
+}
+
+/** RemovalPolicyWalker **/
+
+typedef struct _LruWalkData LruWalkData;
+struct _LruWalkData
+{
+    LruNode *current;
+};
+
+const StoreEntry *
+lru_walkNext(RemovalPolicyWalker * walker)
+{
+    LruWalkData *lru_walk = walker->_data;
+    LruNode *lru_node = lru_walk->current;
+    if (!lru_node)
+	return NULL;
+    lru_walk->current = (LruNode *) lru_node->node.next;
+    return (StoreEntry *) lru_node->node.data;
+}
+
+static void
+lru_walkDone(RemovalPolicyWalker * walker)
+{
+    RemovalPolicy *policy = walker->_policy;
+    LruPolicyData *lru = policy->_data;
+    assert(strcmp(policy->_type, "lru") == 0);
+    assert(lru->nwalkers > 0);
+    lru->nwalkers -= 1;
+    safe_free(walker->_data);
+    cbdataFree(walker);
+}
+
+static RemovalPolicyWalker *
+lru_walkInit(RemovalPolicy * policy)
+{
+    LruPolicyData *lru = policy->_data;
+    RemovalPolicyWalker *walker;
+    LruWalkData *lru_walk;
+    lru->nwalkers += 1;
+    walker = xcalloc(1, sizeof(*walker));
+    lru_walk = xcalloc(1, sizeof(*lru_walk));
+    walker->_policy = policy;
+    walker->_data = lru_walk;
+    walker->Next = lru_walkNext;
+    walker->Done = lru_walkDone;
+    lru_walk->current = (LruNode *) lru->list.head;
+    cbdataAdd(walker, cbdataXfree, 0);
+    return walker;
+}
+
+/** RemovalPurgeWalker **/
+
+typedef struct _LruPurgeData LruPurgeData;
+struct _LruPurgeData
+{
+    LruNode *current;
+    LruNode *start;
+};
+
+static StoreEntry *
+lru_purgeNext(RemovalPurgeWalker * walker)
+{
+    LruPurgeData *lru_walker = walker->_data;
+    RemovalPolicy *policy = walker->_policy;
+    LruPolicyData *lru = policy->_data;
+    LruNode *lru_node;
+    StoreEntry *entry;
+  try_again:
+    lru_node = lru_walker->current;
+    if (!lru_node || walker->scanned >= walker->max_scan)
+	return NULL;
+    walker->scanned += 1;
+    lru_walker->current = (LruNode *) lru_node->node.next;
+    if (lru_walker->current == lru_walker->start) {
+	/* Last node found */
+	lru_walker->current = NULL;
+    }
+    entry = (StoreEntry *) lru_node->node.data;
+    dlinkDelete(&lru_node->node, &lru->list);
+    if (storeEntryLocked(entry)) {
+	/* Shit, it is locked. we can't return this one */
+	walker->locked++;
+	dlinkAdd(entry, &lru_node->node, &lru->list);
+	goto try_again;
+    }
+    memPoolFree(lru_node_pool, lru_node);
+    lru->count -= 1;
+    SET_POLICY_NODE(entry, NULL);
+    return entry;
+}
+
+static void
+lru_purgeDone(RemovalPurgeWalker * walker)
+{
+    RemovalPolicy *policy = walker->_policy;
+    LruPolicyData *lru = policy->_data;
+    assert(strcmp(policy->_type, "lru") == 0);
+    assert(lru->nwalkers > 0);
+    lru->nwalkers -= 1;
+    safe_free(walker->_data);
+    cbdataFree(walker);
+}
+
+static RemovalPurgeWalker *
+lru_purgeInit(RemovalPolicy * policy, int max_scan)
+{
+    LruPolicyData *lru = policy->_data;
+    RemovalPurgeWalker *walker;
+    LruPurgeData *lru_walk;
+    lru->nwalkers += 1;
+    walker = xcalloc(1, sizeof(*walker));
+    lru_walk = xcalloc(1, sizeof(*lru_walk));
+    walker->_policy = policy;
+    walker->_data = lru_walk;
+    walker->max_scan = max_scan;
+    walker->Next = lru_purgeNext;
+    walker->Done = lru_purgeDone;
+    lru_walk->start = lru_walk->current = (LruNode *) lru->list.head;
+    cbdataAdd(walker, cbdataXfree, 0);
+    return walker;
+}
+
+static void
+lru_free(RemovalPolicy * policy)
+{
+    LruPolicyData *lru = policy->_data;
+    /* Make some verification of the policy state */
+    assert(strcmp(policy->_type, "lru") == 0);
+    assert(lru->nwalkers);
+    assert(lru->count);
+    /* Ok, time to destroy this policy */
+    safe_free(policy->_data);
+    memset(policy, 0, sizeof(*policy));
+    cbdataFree(policy);
+}
+
+RemovalPolicy *
+createRemovalPolicy_lru(wordlist *args)
+{
+    RemovalPolicy *policy;
+    LruPolicyData *lru_data;
+    /* no arguments expected or understood */
+    assert(!args);
+    /* Initialize */
+    if (!lru_node_pool)
+	lru_node_pool = memPoolCreate("LRU policy node", sizeof(LruNode));
+    /* Allocate the needed structures */
+    policy = xcalloc(1, sizeof(*policy));
+    lru_data = xcalloc(1, sizeof(*lru_data));
+    /* cbdata register the policy */
+    cbdataAdd(policy, cbdataXfree, 0);
+    /* Initialize the URL data */
+    lru_data->policy = policy;
+    /* Populate the policy structure */
+    policy->_type = "lru";
+    policy->_data = lru_data;
+    policy->Free = lru_free;
+    policy->Add = lru_add;
+    policy->Remove = lru_remove;
+    policy->Referenced = lru_referenced;
+    policy->Dereferenced = lru_referenced;
+    policy->WalkInit = lru_walkInit;
+    policy->PurgeInit = lru_purgeInit;
+    /* Increase policy usage count */
+    nr_lru_policies += 0;
+    return policy;
+}
+
+
+#if OLD_UNUSED_CODE
+/*
+ * storeUfsDirCheckExpired
+ *
+ * Check whether the given object is expired or not
+ * It breaks layering a little by calling the upper layers to find
+ * out whether the object is locked or not, but we can't help this
+ * right now.
+ */
+static int
+storeUfsDirCheckExpired(SwapDir * SD, StoreEntry * e)
+{
+    if (storeEntryLocked(e))
+	return 0;
+    if (EBIT_TEST(e->flags, RELEASE_REQUEST))
+	return 1;
+    if (EBIT_TEST(e->flags, ENTRY_NEGCACHED) && squid_curtime >= e->expires)
+	return 1;
+
+#if HEAP_REPLACEMENT
+    /*
+     * with HEAP_REPLACEMENT we are not using the LRU reference age, the heap
+     * controls the replacement of objects.
+     */
+    return 1;
+#else
+    if (squid_curtime - e->lastref > storeUfsDirExpiredReferenceAge(SD))
+	return 1;
+    return 0;
+#endif
+}
+
+/*
+ * storeUfsDirExpiredReferenceAge
+ *
+ * The LRU age is scaled exponentially between 1 minute and
+ * Config.referenceAge , when store_swap_low < store_swap_size <
+ * store_swap_high.  This keeps store_swap_size within the low and high
+ * water marks.  If the cache is very busy then store_swap_size stays
+ * closer to the low water mark, if it is not busy, then it will stay
+ * near the high water mark.  The LRU age value can be examined on the
+ * cachemgr 'info' page.
+ */
+static time_t
+storeUfsDirExpiredReferenceAge(SwapDir * SD)
+{
+    double x;
+    double z;
+    time_t age;
+    long store_high, store_low;
+
+    store_high = (long) (((float) SD->max_size *
+	    (float) Config.Swap.highWaterMark) / (float) 100);
+    store_low = (long) (((float) SD->max_size *
+	    (float) Config.Swap.lowWaterMark) / (float) 100);
+    debug(20, 20) ("RA: Dir %s, hi=%d, lo=%d, cur=%d\n", SD->path, store_high,
+	store_low, SD->cur_size);
+
+    x = (double) (store_high - SD->cur_size) / (store_high - store_low);
+    x = x < 0.0 ? 0.0 : x > 1.0 ? 1.0 : x;
+    z = pow((double) (Config.referenceAge / 60), x);
+    age = (time_t) (z * 60.0);
+    if (age < 60)
+	age = 60;
+    else if (age > Config.referenceAge)
+	age = Config.referenceAge;
+    return age;
+}
+#endif /* OLD_UNUSED_CODE */
